%undefine __cmake_in_source_build
%global _lto_cflags %{nil}
%global soversion 6.12

Name:           dart
Version:        6.12.1
Release:        1%{?dist}
Summary:        Dynamic Animation and Robotics Toolkit

License:        BSD
URL:            http://dartsim.github.io/
Source0:        https://github.com/dartsim/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  assimp-devel >= 3.0.0
BuildRequires:  boost-devel
BuildRequires:  bullet-devel 
BuildRequires:  cmake
BuildRequires:  coin-or-Ipopt-devel
BuildRequires:  console-bridge-devel
BuildRequires:  doxygen
BuildRequires:  eigen3-static >= 3.0.5
BuildRequires:  fcl-devel >= 0.2.9
BuildRequires:  flann-devel >= 1.8.4
BuildRequires:  freeglut-devel
BuildRequires:  gcc-c++
BuildRequires:  libccd-devel >= 1.4.0
BuildRequires:  lz4-devel
BuildRequires:  NLopt-devel
BuildRequires:  OpenSceneGraph-devel >= 3.0
BuildRequires:  octomap-devel
BuildRequires:  ode-devel
BuildRequires:  tinyxml-devel >= 2.6.2
BuildRequires:  tinyxml2-devel
BuildRequires:  urdfdom-devel

# Remove boost from the list of pkgconfig dependencies
# Boost doesn't install pkgconfig files
Patch0: %{name}-6.12.1-pcdeps.patch
# Disable vendor CMAKE_CXX_FLAGS_RELEASE override
Patch1: %{name}-6.12.1-cflags.patch

%description
DART (Dynamic Animation and Robotics Toolkit) is a collaborative, cross-
platform, open source library created by the Georgia Tech Graphics Lab and 
Humanoid Robotics Lab. The library provides data structures and algorithms 
for kinematic and dynamic applications in robotics and computer animation. 
DART is distinguished by its accuracy and stability due to its use of 
generalized coordinates to represent articulated rigid body systems and 
computation of Lagrange's equations derived from D.Alembert's principle to 
describe the dynamics of motion.

%package devel
Summary: Development files and libraries for ${name}
Requires: %{name}%{_isa} = %{version}-%{release}

%description devel
${summary}.

%package doc
BuildArch: noarch
Summary: Documentation for %{name}

%description doc
%{summary}.

%prep
%setup -qn %{name}-%{version}
%patch0 -p1 -b .pcdeps
%patch1 -p1 -b .cflags
sed -i 's/(LIBRARY_INSTALL_DIR "lib")/(LIBRARY_INSTALL_DIR "%{_lib}")/' CMakeLists.txt
sed -i 's|lib/pkgconfig|%{_lib}/pkgconfig|' CMakeLists.txt

%build
%cmake .. \
  -DDART_BUILD_EXAMPLES=OFF \
  -DDART_BUILD_TUTORIALS=OFF \
  -DLIBRARY_INSTALL_DIR=%{_lib} \
  -DCMAKE_BUILD_TYPE=Release
%cmake_build
%cmake_build --target tests

%install
%cmake_install

%check
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
%ctest --verbose || exit 0

%files
%doc README.md CHANGELOG.md
%license LICENSE
%{_libdir}/*.so.%{version}
%{_libdir}/*.so.%{soversion}
%{_datadir}/%{name}

%files devel
%{_includedir}/%{name}
%{_libdir}/*.so
%{_libdir}/pkgconfig/%{name}.pc

%files doc
%{_docdir}/dart

%changelog
* Sun Jan 23 2022 Rich Mattes <richmattes@gmail.com> - 6.12.1-1
- Update to release 6.12.1

* Mon Mar 08 2021 Rich Mattes <richmattes@gmail.com> - 6.9.5-1
- Update to release 6.9.5

* Thu Aug 20 2020 Rich Mattes <richmattes@gmail.com> - 6.9.2-2
- Add patch to update pkgconfig external deps.

* Wed Aug 19 2020 Rich Mattes <richmattes@gmail.com> - 6.9.2-1
- Initial package
